﻿// interfaSys QA: CHECK TYPES
import com.xfactorstudio.xml.xpath.types.QueryPart;
import com.xfactorstudio.xml.xpath.types.Axis;
import com.xfactorstudio.xml.xpath.Axes;
import com.xfactorstudio.xml.xpath.types.Predicate;

class com.xfactorstudio.xml.xpath.types.Path extends QueryPart{
	public var nodeName:String = "path";
	
	public function Path(){
		super();
	}

	public function register():Void {
		this.parentNode.hasPaths = true;
	}

	/**
	 * appendChild
	 * 
	 * @description The type of child is set to Object because we don't know the
	 * <br />nature of the child.
	 * 
	 * @param	child	the child element
	 */
	public function appendChild(child:QueryPart):Object {
		// Casted nodeValue to Number
		if(this.childNodes.length == 0 && Number(child.nodeValue) == Axes.SELF){
			this.childNodes.push(new Axis(Axes.CHILD));
			this.childNodes[this.childNodes.length-1].parentNode = this;
		}
		
		if(!(this.childNodes[this.childNodes.length-1] instanceof Axis) && !(child instanceof Axis)&& !(child instanceof Predicate)){
			this.childNodes.push(new Axis(Axes.CHILD));
			this.childNodes[this.childNodes.length-1].parentNode = this;
		}
		
		this.childNodes.push(child);
		this.childNodes[this.childNodes.length-1].parentNode = this;
		return this.childNodes[this.childNodes.length-1];
	}

	public function clone():Path {
		var obj:Path = new Path();
		super.clone(obj);
		return obj;
	}

	public function execute(context:Array):Object {
		for(var j:Number = 0 ; j<this.childNodes.length ; j++){
			context = this.childNodes[j].execute(context);
		}
		return context;
	}
}