﻿// interfaSys QA: OK
import com.xfactorstudio.xml.xpath.XPathLexer;
import com.xfactorstudio.xml.xpath.Axes;
import com.xfactorstudio.xml.xpath.types.Path;
import com.xfactorstudio.xml.xpath.types.QueryPart;
import com.xfactorstudio.xml.xpath.types.Axis;
import com.xfactorstudio.xml.xpath.types.Predicate;
import com.xfactorstudio.xml.xpath.types.Identifier;
import com.xfactorstudio.xml.xpath.types.Operator;
import com.xfactorstudio.xml.xpath.types.Func;
import com.xfactorstudio.xml.xpath.types.Group;
import com.xfactorstudio.xml.xpath.XPathFunctions;


class com.xfactorstudio.xml.xpath.types.Query extends QueryPart{
	public var pathString:String;
	// Needs to be a generic Object
	public var currentChild:Object;

	public function Query(query:String) {
		super();
		XPathFunctions.registerDefaultFunctions();
		currentChild = this;
		this.nodeName = "query";
		this.pathString = query;
		var lex:XPathLexer = new XPathLexer();
		lex.handler = this;
		var s:Number = getTimer();
		lex.parse(this.pathString);
	}	
	
	public function onFunctionStart(name:Number):Void {
		onNotPath();
		currentChild = currentChild.appendChild(new Func(name));
	}
	
	public function onComma():Void {
	}

	public function onGroupStart():Void {
		onNotPath();
		currentChild = currentChild.appendChild(new Group());
	}

	public function onGroupEnd():Void {
		while(!(currentChild instanceof Group)){
			currentChild = currentChild.parentNode;
		}
		currentChild = currentChild.parentNode;
	}

	public function onFunctionEnd():Void {
		while(!(currentChild instanceof Func)){
			currentChild = currentChild.parentNode;
		}
		currentChild = currentChild.parentNode;
	}

	public function onIdentifier(name:String):Void {
		if(name == "."){
			onAxis(Axes.SELF);
			onAxis(Axes.CHILD);
		}else{
			onPathPart();
			currentChild.appendChild(new Identifier(name));
		}
	}

	public function onAxis(axis:Number):Void {
		onPathPart();
		currentChild.appendChild(new Axis(axis));
	}

	public function onPredicateStart():Void {
		currentChild = currentChild.appendChild(new Predicate());
	}

	public function onPredicateEnd():Void {
		while(!(currentChild instanceof Predicate)){
			currentChild = currentChild.parentNode;
		}
		currentChild = currentChild.parentNode;
	}

	public function onOperator(type:Number):Void {
		onNotPath();
		currentChild.appendChild(new Operator(type));
	}

	public function onLitteral(litteral:String):Void {
		onNotPath();
		currentChild.appendChild(litteral);
	}

	public function onNumber(num:Number):Void {
		onNotPath();
		currentChild.appendChild(num);
	}

	public function onPathPart():Void {
		if(!(currentChild instanceof Path)){
			currentChild = currentChild.appendChild(new Path());
		}
	}

	public function onNotPath():Void {
		if(currentChild instanceof Path){
			currentChild = currentChild.parentNode;
		}
	}
	
	public function clone():Query{
		var obj:Query = new Query();
		super.clone(obj);
		return obj;
	}

	public function execute(context:Array):Array {
		var p:Predicate = new Predicate();
		for(var j:Number = 0 ; j<this.childNodes.length ; j++){
			p.appendChild(this.childNodes[j]);
		}
		
		var retArray:Array = new Array();
		for(var i:Number = 0 ; i<context.length ; i++){
			var test:Predicate = p.clone();
			var val:Object = Predicate.staticEvaluate(test,context[i]);
			if(val instanceof Array){
				retArray = retArray.concat(Predicate.staticEvaluate(test,context[i],context));
			}else{
				retArray.push(val);
			}
		}
		return retArray;
	}
}